/*
 * This source file is part of KEOS (Free 3D Engine)
 * For the latest info, see http://www.keosengine.org/
 * E-mails : thierry.vouriot@keosengine.org, yeri@keosengine.org
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA, or go to
 * http://www.gnu.org/copyleft/lesser.txt.
 *
 */

#include "KeosFile.h"

namespace Keos
{
    //=======================================================================
    // CFile implementation
    //=======================================================================

    //-----------------------------------------------------------------------
    CFile::CFile(const String& strName) :
    m_strName(strName)
    {
        std::replace(m_strName.begin(), m_strName.end(), '/', '\\');
    }

    //-----------------------------------------------------------------------
    CFile::CFile(const char* strName) :
    m_strName(strName)
    {
        std::replace(m_strName.begin(), m_strName.end(), '/', '\\');
    }

    //-----------------------------------------------------------------------
    bool CFile::Exists() const
    {
	      std::ifstream File(m_strName.c_str());
        return File.is_open();
    }

    //-----------------------------------------------------------------------
    const String& CFile::Fullname() const
    {
        return m_strName;
    }

    //-----------------------------------------------------------------------
    String CFile::Filename() const
    {
        String::size_type Pos = m_strName.find_last_of("\\/");

        if (Pos != String::npos)
            return m_strName.substr(Pos + 1, String::npos);
        else
            return m_strName;
    }

    //-----------------------------------------------------------------------
    String CFile::ShortFilename() const
    {
        return Filename().substr(0, Filename().find_last_of("."));
    }

    //-----------------------------------------------------------------------
    String CFile::Extension() const
    {
        String::size_type Pos = m_strName.find_last_of(".");
        if (Pos != String::npos)
            return m_strName.substr(Pos + 1, String::npos);
        else
            return "";
    }

} // namespace Keos
